
// Full Screen Clock
// For Touchshield Slide
// 1.18.09 
// Sasha Gelbart -- sashag@mac.com

#include "math.h"
#include "subPGraphics.h"

int theHrs = 0, theMins = 0, theSecs = 0, theDate = 1, theDay = 1;

int rotAdj = 90; //re-orient the screen coordinates 90 degrees

float hrMarkAngle, minMarkAngle, dateDayAngle = 270;  //for placing the hour and minute/second markers and date window

float oldSecsX = 160, oldSecsY = 120, 	//there has to be a better way to set up these variables
oldSecsX1 = 160, oldSecsY1 = 120,
oldMinX = 160, oldMinY = 120,
oldMinX1 = 160, oldMinY1 = 120, 
oldHrX = 160, oldHrY = 120, 
oldHrX1 = 160, oldHrY1 = 120, //circle on hour hand
oldHrX2 = 160, oldHrY2 = 120,    
oldSecsRedX = 160, oldSecsRedY = 120,
oldSecsRedX1 =160, oldSecsRedY1 = 120;

int x, y, i, x1=120, a, b, a1, b1;              //variables for trig drawing

//-------------------------------- functions -----------------------------------------

void setTime(int hr , int minute, 
int second)         //set initial time
{
  theHrs = hr;
  theMins = minute;
  theSecs = second;
}

void drawBackground(void)      //draw static clock elements
{
  stroke(0,5,0);             //draw screen bounds
  fill(0,5,0);
  rect(0,0,320,240);

  drawMinuteMarkers();
}

void drawMinuteMarkers(void)   //draw minute hack markings ** "0" is at 6 o'clock by default, turns clockwise
{
  minMarkAngle=90; //starting point shifted to make 'left-hand top'

  for (i=1; i<=60; i++)  
  {
    minMarkAngle+=6;

    a=(x1-120)*cos(3.14*minMarkAngle/180)-(90)*sin(3.14*minMarkAngle/180)+160;
    b=(x1-120)*sin(3.14*minMarkAngle/180)+(90)*cos(3.14*minMarkAngle/180)+120;
    a1=(x1-120)*cos(3.14*minMarkAngle/180)-(200)*sin(3.14*minMarkAngle/180)+160;
    b1=(x1-120)*sin(3.14*minMarkAngle/180)+(200)*cos(3.14*minMarkAngle/180)+120;

    stroke(0,60,0);
    line(a,b,a1,b1);

    if (!(i % 5)){
      stroke(0,120,0);
      line(a,b,a1,b1);
    }
    if (i == 30){          //6 o'clock position
      stroke(0,120,0);
      fill(0,60,0);
      line(a,b,a1,b1);
      rect(a1-60,(b1-3),60,6);
    }
    else if (i == 60){          //12 o'clock position
      stroke(0,120,0);
      fill(0,60,0);
      line(a,b,a1,b1);
      rect(a1,(b1-6),80,12);
    }

  }
  stroke(0,240,0);         //draw screen bounds
  noFill();
  rect(0,0,320,240);
}

void drawHands(void)       //draw the hands
{
  int a,b,c,d,k,l,e,f,g,h,m,n,o,p,cc,dd,ee,ff, x1=120;  //this is a bit ridiculous... need to rethink this as a struct
  float hrHand, minHand, secHand;

  //draw secs
  secHand = (theSecs*6);
  a=(x1-120)*cos(3.14*(secHand+rotAdj)/180)-(80)*sin(3.14*(secHand+rotAdj)/180)+160;
  b=(x1-120)*sin(3.14*(secHand+rotAdj)/180)+(80)*cos(3.14*(secHand+rotAdj)/180)+120;
  k=(x1-120)*cos(3.14*(secHand+rotAdj)/180)-(2)*sin(3.14*(secHand+rotAdj)/180)+160;
  l=(x1-120)*sin(3.14*(secHand+rotAdj)/180)+(2)*cos(3.14*(secHand+rotAdj)/180)+120;

  //draw red second sweep

  m=(x1-120)*cos(3.14*(secHand+rotAdj)/180)-(80)*sin(3.14*(secHand+rotAdj)/180)+160;
  n=(x1-120)*sin(3.14*(secHand+rotAdj)/180)+(80)*cos(3.14*(secHand+rotAdj)/180)+120;
  o=(x1-120)*cos(3.14*(secHand+rotAdj)/180)-(90)*sin(3.14*(secHand+rotAdj)/180)+160;
  p=(x1-120)*sin(3.14*(secHand+rotAdj)/180)+(90)*cos(3.14*(secHand+rotAdj)/180)+120;

  //cleanup old line
  stroke(0,5,0);
  line(oldSecsX1,oldSecsY1, oldSecsX, oldSecsY);
  stroke(0,5,0);
  line(oldSecsRedX,oldSecsRedY,oldSecsRedX1,oldSecsRedY1);

  stroke(0,220,0);
  line(k,l,a,b);

  //draw red sweep
  stroke(240,0,0);
  line(m,n,o,p);

  oldSecsX = a;
  oldSecsY = b;
  oldSecsX1 = k;
  oldSecsY1 = l;
  oldSecsRedX = m;
  oldSecsRedY = n;
  oldSecsRedX1 = o;
  oldSecsRedY1 = p;

  //draw min hand
  minHand = (theMins*6)+(secHand/60);
  c=(x1-120)*cos(3.14*(minHand+rotAdj)/180)-(60)*sin(3.14*(minHand+rotAdj)/180)+160;
  d=(x1-120)*sin(3.14*(minHand+rotAdj)/180)+(60)*cos(3.14*(minHand+rotAdj)/180)+120;
  cc=(x1-120)*cos(3.14*(secHand+rotAdj)/180)-(2)*sin(3.14*(secHand+rotAdj)/180)+160;
  dd=(x1-120)*sin(3.14*(secHand+rotAdj)/180)+(2)*cos(3.14*(secHand+rotAdj)/180)+120;

  stroke(0,5,0);
  line(oldMinX1,oldMinY1,oldMinX, oldMinY);

  stroke(0,240,0); 
  line(cc,dd,c,d);

  oldMinX = c;
  oldMinY = d;
  oldMinX1 = cc;
  oldMinY1 = dd;


  //draw hour hand
  hrHand = (theHrs*30)+(minHand/12);
  e=(x1-120)*cos(3.14*(hrHand+rotAdj)/180)-(40)*sin(3.14*(hrHand+rotAdj)/180)+160;
  f=(x1-120)*sin(3.14*(hrHand+rotAdj)/180)+(40)*cos(3.14*(hrHand+rotAdj)/180)+120;
  g=(x1-120)*cos(3.14*(hrHand+rotAdj)/180)-(28)*sin(3.14*(hrHand+rotAdj)/180)+160;
  h=(x1-120)*sin(3.14*(hrHand+rotAdj)/180)+(28)*cos(3.14*(hrHand+rotAdj)/180)+120;
  ee=(x1-120)*cos(3.14*(secHand+rotAdj)/180)-(2)*sin(3.14*(secHand+rotAdj)/180)+160;
  ff=(x1-120)*sin(3.14*(secHand+rotAdj)/180)+(2)*cos(3.14*(secHand+rotAdj)/180)+120;

  stroke(0,5,0);
  line(oldHrX2,oldHrY2,oldHrX, oldHrY);
  ellipse(oldHrX1, oldHrY1,8,8);

  stroke(0,240,0); 
  line(ee,ff,e,f);
  fill(0,5,0);
  ellipse(g,h,8,8);

  oldHrX = e;
  oldHrY = f;
  oldHrX1 = g;
  oldHrY1 = h;
  oldHrX2 = ee;
  oldHrY2 = ff;

  //Draw Center Circle

  stroke(0,240,0);
  fill(0,5,0);
  ellipse(160, 120, 4, 4);
}

//-------------------------------- setup() and void() -----------------------------------------
void setup()
{
  background(0);         //black background

  setTime(0,0,0);   //set initial time to 12:00:00

  drawBackground();      //draw static clock elements
  drawHands();           //draw the hands
}


void loop()
{
  drawHands();           //draw new hands
  theSecs++;             //increment the seconds
  delay(1100);            //delay for timing accuracy.  Check this against another clock to confirm drift.
}
